--
--
--		MapAmpeln_Test
--@date: 02/10/2012
--@Author: Bluebaby210		www.mod-portal.com
--@Version: v1.0
--
--darf in jede Map eingebaut werden, MapAmpeln.zip darf nicht neu hochgeladen werden
--
--Keine nderung ohne meine Erlaubnis
--No modification without my permission


	--print("   Map: TrafficLights Ampeln2 v1.0 by Bluebaby210 loaded!");

function onCreateAmpeln2(self, id)
	--print("created MapAmpeln2, id: ", id);
	local Ampeln2er = Ampeln2:new(g_server ~= nil, g_client ~= nil);
    local index = g_currentMission:addOnCreateLoadedObject(Ampeln2er);
    Ampeln2er:load(id);
    Ampeln2er:register(true);
end;

Ampeln2 = {}
local Ampeln2_mt = Class(Ampeln2, Object);

function Ampeln2:new(isServer, isClient)
    local self = Object:new(isServer, isClient, Ampeln2_mt);
    self.className = "Ampeln2";
    return self;
end;

function Ampeln2:load(id)

	--Indexe der Lampen laden
	self.red21 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights2.1_Red"));
	self.red22 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights2.2_Red"));

	self.orange21 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights2.1_Orange"));
	self.orange22 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights2.2_Orange"));

	self.green21 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights2.1_Green"));
	self.green22 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights2.2_Green"));
	
	
	--Collis Laden und collis hochsetzen sowie g_currentMission.nodeToVehicles setzen.
	self.colli21 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights2.1_Colli"));
	self.colli22 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights2.2_Colli"));

	x21, y21, z21 = getTranslation(self.colli21);
	x22, y22, z22 = getTranslation(self.colli22);

	setTranslation(self.colli21,x21,0,z21);
	g_currentMission.nodeToVehicle[self.colli21] = {};
	setTranslation(self.colli22,x22,0,z22);
	g_currentMission.nodeToVehicle[self.colli22] = {};

	self.redTime2 = getUserAttribute(id, "TrafficLights2_redTime");
	self.greenTime2 = getUserAttribute(id, "TrafficLights2_greenTime");

	if self.redTime2 < 5 or self.greenTime2 < 5 then
		self.redTime2 = 5;
		self.greenTime2 = 5;
		print ("Warning: Rotphase bzw Gruenphase sollte mindestens 5 sekunden sein ");
	end;

	self.TimerRed21 = (self.redTime2 * 1000);
	self.TimerRed21Backup = self.TimerRed21 + 2000;
	self.TimerGreen21 = (self.greenTime2 * 1000);
	self.TimerGreen21Backup = self.TimerGreen21 + 2000;
	self.TimerRed22 = (self.redTime2 * 1000);
	self.TimerRed22Backup = self.TimerRed22 + 2000;
	self.TimerGreen22 = (self.greenTime2 * 1000);
	self.TimerGreen22Backup = self.TimerGreen22 + 2000;
	self.red21Started = true;
	self.red22Started = false;
	self.green21Started = false;
	self.green22Started = false;
	
	self.orangeFlashing = true;
	self.orangeLightTimer = 2000;
	self.orangeLightTimerBackup = 2000;
	self.startFirst = true;
	self.allowsControl = true;
		
	if self.isServer then
		if g_server.netIsRunning then
			self.allowsControl = false;
		end;
	end;
	
	if g_client.netIsRunning == true then
		self.allowsControl = false;
	end;
	
	self.MpStarted = 0;

end;

function Ampeln2:delete()
end;

function Ampeln2:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Ampeln2:keyEvent(unicode, sym, modifier, isDown)
end;

function Ampeln2:TriggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)

end;

function Ampeln2:update(dt)

	if self.allowsControl then
		if self.startFirst then
			setVisibility(self.red21,true);
			setVisibility(self.red22,true);
			setVisibility(self.orange21,false);
			setVisibility(self.orange22,false);
			setVisibility(self.green21,false);
			setVisibility(self.green22,false);
			self.startFirst = false;
		end;
			if self.red21Started then
				self.TimerRed21 = self.TimerRed21 - dt;
					if self.TimerRed21 <= 2000 and self.TimerRed21 >= 1000 then
						setVisibility(self.orange21,true);
					elseif self.TimerRed21 <= 1000 and self.TimerRed21 >= 0 then
						setVisibility(self.red21,false);
						setVisibility(self.orange21,false);
						setVisibility(self.green21,true);
						setTranslation(self.colli21,x21,-5,z21);
						self.green21Started = true;
						self.red21Started = false;
						self.TimerRed21 = self.TimerRed21Backup;
					end;
			elseif self.green21Started then
				self.TimerGreen21 = self.TimerGreen21 - dt;
					if self.TimerGreen21 <= 2000 and self.TimerGreen21 >= 1000 then
						setVisibility(self.green21,false);
						setVisibility(self.orange21,true);
					elseif self.TimerGreen21 <= 1000 and self.TimerGreen21 >= 0 then
						self.red22Started = true;
						setVisibility(self.orange21,false);
						setVisibility(self.red21,true);
						setTranslation(self.colli21,x21,0,z21);
						self.green21Started = false;
						self.TimerGreen21 = self.TimerGreen21Backup;
					end;
			elseif self.red22Started then
				self.TimerRed22 = self.TimerRed22 - dt;
					if self.TimerRed22 <= 2000 and self.TimerRed22 >= 1000 then
						setVisibility(self.orange22,true);
					elseif self.TimerRed22 <= 1000 and self.TimerRed22 >= 0 then
						setVisibility(self.red22,false);
						setVisibility(self.orange22,false);
						setVisibility(self.green22,true);
						setTranslation(self.colli22,x22,-5,z22);
						self.green22Started = true;
						self.red22Started = false;
						self.TimerRed22 = self.TimerRed21Backup;
					end;
			elseif self.green22Started then
				self.TimerGreen22 = self.TimerGreen22 - dt;
					if self.TimerGreen22 <= 2000 and self.TimerGreen22 >= 1000 then
						setVisibility(self.green22,false);
						setVisibility(self.orange22,true);
					elseif self.TimerGreen22 <= 1000 and self.TimerGreen22 >= 0 then
						setVisibility(self.orange22,false);
						setVisibility(self.red22,true);
						setTranslation(self.colli22,x22,0,z22);
						self.red21Started = true;
						self.green22Started = false;
						self.TimerGreen22 = self.TimerGreen22Backup;
					end;
			end;
	end;
		
	if not self.allowsControl then
		if self.MpStarted < 4000 then
			g_currentMission:addWarning(g_i18n:getText("Ampel_MP_W"));
			self.MpStarted = self.MpStarted + dt;
		end;
		if self.orangeFlashing then
			setVisibility(self.red21,false);
			setVisibility(self.red22,false);
			setVisibility(self.green21,false);
			setVisibility(self.green22,false);
			setTranslation(self.colli21,x21,-5,z21);
			setTranslation(self.colli22,x22,-5,z22);
			self.orangeFlashing = false;
		end;
		if self.orangeFlashing == false then
			if self.orangeLightTimer >= 0 then
				self.orangeLightTimer = self.orangeLightTimer - dt;
				if self.orangeLightTimer <= 2000 and self.orangeLightTimer >= 1000 then
					setVisibility(self.orange21,false);
					setVisibility(self.orange22,false);
				elseif self.orangeLightTimer <= 1000 and self.orangeLightTimer >= 0 then
					setVisibility(self.orange21,true);
					setVisibility(self.orange22,true);
				elseif self.orangeLightTimer <= 0 then
					self.orangeLightTimer = self.orangeLightTimerBackup;
				end;
			end;
		end;

	end;

end;

function Ampeln2:draw()
end;



